/********************************************************************************
 *	applic.h
 *
 *	THINK C 4.0 Application Shell Header
 *
 *	Written by Paco Xander Nathan
 *	1990, Motorola Inc.  Public domain source code.
 ********************************************************************************/

#define _H_applic


#include <MacTypes.h>
#include <QuickDraw.h>
#include <WindowMgr.h>
#include <EventMgr.h>
#include <pascal.h>
#include <Color.h>


#define DEVELOPING

#ifndef PROTOTYPES
#define PROTOTYPES
#endif

#ifndef BYTE
#define BYTE			char
#endif

#ifndef UBYTE
#define UBYTE			unsigned char
#endif

#ifndef WORD
#define WORD			short
#endif

#ifndef UWORD
#define UWORD			unsigned short
#endif

#ifndef LONG
#define LONG			long
#endif

#ifndef ULONG
#define ULONG			unsigned long
#endif

#ifndef NULL
#define NULL			0L
#endif


#define	FONTNUM			systemFont
#define	FONTSIZE		12
#define RSRCBASE		128
#define SBAR_WIDTH		16

#define BotRight(r)		(* (Point *) &(r).bottom)
#define TopLeft(r)		(* (Point *) &(r).top)
#define Linear(x,y,z)	((x <= y) && (y <= z))
#define Max(a,b)		((a) > (b) ? (a) : (b))
#define Min(a,b)		((a) < (b) ? (a) : (b))


typedef struct {
	short frames;			/* number of cursor frames */
	short which;			/* used as framce counter */
	CursHandle curs[1];		/* can actually become any number */
} acur, *acurPtr, **acurHandle;


typedef struct {
	Boolean hasWNE;
	Boolean hasSound;
	Boolean hasColor;
	Boolean inBackground;
} MachineConfig;


/* External Data Structures
 */
extern acurHandle
	curList;

extern SysEnvRec
	theWorld;

extern MachineConfig
	laMachine;


/* External Function Prototypes
 */
#ifdef PROTOTYPES
void ApplSpinCurs (Boolean reset);
Boolean ApplAbort (void);
void ApplTask (void);
void ApplQuit (void);
#endif
